package de.tudarmstadt.maki.simonstrator.api.component.vehicular.api.information;

import java.io.Serializable;

/**
 * @deprecated We should not have a second representation of locations within
 *             the API. Try to mask the functionality behind Location (which now
 *             provides speed and heading)
 */
@Deprecated
public class Position implements Serializable, Comparable<Position> {
    /**
     *
     */
    private static final long serialVersionUID = -5007352031660976321L;
    public static final double EQUAL_DISTANCE = 0.0;
    private static final double EQUAL_HEADING = 5;
    private static final double EQUAL_ALT = 10;
    private double _y;
    private double _x;
    private double _heading;
    private double _alt;
    private double _speed;

    public Position(double pX, double pY, double pAlt, double pHeading, double pSpeed) {
        _x = pX;
        _y = pY;
        _alt = pAlt;
        _heading = pHeading;
        _speed = pSpeed;
    }

    public Position(double pX, double pY, double pAlt, double pHeading) {
        this(pX, pY, pAlt, pHeading, 0);
    }

    public double getY() {
        return _y;
    }

    public void setY(double pY) {
        _y = pY;
    }

    public double getX() {
        return _x;
    }

    public void setX(double pX) {
        _x = pX;
    }

    public double getHeading() {
        return _heading;
    }

    public void setHeading(double pHeading) {
        _heading = pHeading;
    }

    public double getAlt() {
        return _alt;
    }

    public void setAlt(double pAlt) {
        _alt = pAlt;
    }

    public double getSpeed() {
        return _speed;
    }

    public void setSpeed(double pSpeed) {
        _speed = pSpeed;
    }

    @Override
    public String toString() {
        return _y + "/" + _x + " (" + _heading + ")";
    }

    @Override
    public int hashCode() {
        return 0;
    }

    @Override
    public boolean equals(Object pObj) {
        if (pObj instanceof Position) {
            Position start = (Position) pObj;

            double difference = LocationUtils.calculateDistance(start, this);
            if (difference <= EQUAL_DISTANCE) {
                if (Math.abs(getAlt() - start.getAlt()) < EQUAL_ALT) {
                    if (Math.abs(getHeading() - start.getHeading()) < EQUAL_HEADING) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    @Override
    public int compareTo(Position pPosition) {
        if (Math.abs(_y - pPosition.getY()) < 1 / 1000.0
                && Math.abs(_x - pPosition.getX()) < 1 / 1000.0
                && Math.abs(_alt - pPosition.getAlt()) <= EQUAL_ALT
                && Math.abs(_heading - pPosition.getHeading()) <= EQUAL_HEADING) {
            if (equals(pPosition)) {
                return 0;
            }
        }
        int compare = Double.compare(_y, pPosition.getY());

        if (compare == 0) {
            compare = Double.compare(_x, pPosition.getX());
            if (compare == 0) {
                compare = Double.compare(_alt, pPosition.getAlt());
                if (compare == 0) {
                    compare = Double.compare(_heading, pPosition.getHeading());
                }
            }
        }

        return compare;
    }
}
